package com.gic.auth.service;

import java.util.List;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.dto.UserDTO;
import com.gic.auth.dto.UserListDTO;
import com.gic.auth.qo.UserListQO;

/**
 * @author guojx
 * @date 2019/7/16 6:48 PM
 */
public interface UserApiService {

    /**
     * 新增用户
     * @param userDTO
     * @return
     */
    ServiceResponse<Integer> saveUser(UserDTO userDTO);

    /**
     * 编辑
     * @param userDTO
     * @return
     */
    ServiceResponse editUser(UserDTO userDTO);

    /**
     * 用户详情
     * @Title: getUserById 
     * @Description:
      * @author guojuxing
     * @param userId 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.auth.dto.UserDTO> 
      */
    ServiceResponse<UserDTO> getUserById(Integer userId);

    /**
     * 删除
     * @Title: delete 
     * @Description:
      * @author guojuxing
     * @param userId 
     * @return  com.gic.api.base.commons.ServiceResponse<java.lang.Void> 
      */
    ServiceResponse<Void> delete(Integer userId);

    /**
     * 企业查询超级管理员
     * @param enterpriseId
     * @return
     */
    ServiceResponse<UserDTO> getUserByEnterpriseId(Integer enterpriseId);

    ServiceResponse<List<UserDTO>> listUserByPhoneNumber(String phoneNumber);

    ServiceResponse<UserDTO> login(String phoneNumber, Integer enterpriseId, String password);

    /**
     * 分页查询管理员列表数据
     * @Title: pageUser 
     * @Description:
      * @author guojuxing
     * @param params 
     * @return  com.gic.api.base.commons.ServiceResponse<com.gic.api.base.commons.Page<com.gic.auth.dto.UserDTO>> 
      */
    ServiceResponse<Page<UserListDTO>> pageUser(UserListQO params);
}
