package com.gic.auth.dao.mapper;

import com.gic.auth.entity.TabSysMenu;

import java.util.List;

public interface TabSysMenuMapper {
    /**
     * 根据主键删除
     *
     * @param menuId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer menuId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabSysMenu record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabSysMenu record);

    /**
     * 根据主键查询
     *
     * @param menuId 主键
     * @return 实体对象
     */
    TabSysMenu selectByPrimaryKey(Integer menuId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabSysMenu record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabSysMenu record);

    List<TabSysMenu> listMenu();
}