package com.gic.auth.dao.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.gic.auth.dto.UserListDTO;
import com.gic.auth.entity.TabSysUser;
import com.gic.auth.qo.UserListQO;

public interface TabSysUserMapper {
    /**
     * 根据主键删除
     *
     * @param userId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer userId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabSysUser record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabSysUser record);

    /**
     * 根据主键查询
     *
     * @param userId 主键
     * @return 实体对象
     */
    TabSysUser selectByPrimaryKey(Integer userId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabSysUser record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabSysUser record);

    /**
     * 手机号码查询个数
     * @param phone
     * @param userId
     * @param enterpriseId
     * @return
     */
    int countByPhone(@Param("phone") String phone, @Param("userId") Integer userId, @Param("enterpriseId") Integer enterpriseId);

    TabSysUser selectByEnterpriseId(@Param("enterpriseId") Integer enterpriseId);

    List<TabSysUser> listAllUserByPhoneNumber(@Param("phoneNumber") String phoneNumber);

    TabSysUser login(@Param("phoneNumber") String phoneNumber,
                  @Param("password") String password,
                  @Param("enterpriseId") Integer enterpriseId);

    /**
     * 列表查询
     * @Title: listUser 
     * @Description:
      * @author guojuxing
     * @param params 
     * @return  java.util.List<com.gic.auth.entity.TabSysUser> 
      */
    List<UserListDTO> listUser(UserListQO params);

    /**
     * 逻辑删除
     * @Title: deleteById 
     * @Description:
      * @author guojuxing
     * @param userId 
     * @return  int 
      */
    int deleteById(@Param("userId") Integer userId);
}