package com.gic.auth.dao.mapper;

import com.gic.auth.entity.TabSysUserResource;
import com.gic.auth.entity.TabSysUserRole;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface TabSysUserResourceMapper {
    /**
     * 根据主键删除
     *
     * @param userResourceId 主键
     * @return 更新条目数
     */
    int deleteByPrimaryKey(Integer userResourceId);

    /**
     * 插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insert(TabSysUserResource record);

    /**
     * 动态插入一条记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int insertSelective(TabSysUserResource record);

    /**
     * 根据主键查询
     *
     * @param userResourceId 主键
     * @return 实体对象
     */
    TabSysUserResource selectByPrimaryKey(Integer userResourceId);

    /**
     * 根据主键动态更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKeySelective(TabSysUserResource record);

    /**
     * 根据主键更新记录
     *
     * @param record 实体对象
     * @return 更新条目数
     */
    int updateByPrimaryKey(TabSysUserResource record);

    TabSysUserResource existUserResource(@Param("enterpriseId") Integer enterpriseId, @Param("resourceId") Integer resourceId);

    List<Map<String, Object>> countByResourceIds(@Param("enterpriseId") Integer enterpriseId, @Param("ids") List<Integer> resourceIds);

    /**
     * 删除用户关联数据
     * @Title: deleteByUserId 
     * @Description:
      * @author guojuxing
     * @param userId 
     * @return  int 
      */
    int deleteByUserId(@Param("userId") Integer userId);
    /**
     * 查询用户关联数据
     * @Title: listUserResourceByUserId 
     * @Description:
      * @author guojuxing
     * @param userId 
     * @return  java.util.List<com.gic.auth.entity.TabSysUserRole> 
      */
    List<TabSysUserResource> listUserResourceByUserId(@Param("userId") Integer userId);
}