package com.gic.auth.service.impl;

import com.gic.auth.constant.AuthorizationStatusEnum;
import com.gic.auth.dao.mapper.TabSysUnionEnterpriseResourceMapper;
import com.gic.auth.entity.TabSysUnionEnterpriseResource;
import com.gic.auth.service.UnionEnterpriseResourceService;
import com.gic.enterprise.constants.Constants;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service("unionEnterpriseResourceService")
public class UnionEnterrpiseResourceServiceImpl implements UnionEnterpriseResourceService {
    @Autowired
    private TabSysUnionEnterpriseResourceMapper tabSysUnionEnterpriseResourceMapper;

    @Override
    public int saveResource(Integer unionId, Long resourceId, int type, Integer enterpriseId) {
        TabSysUnionEnterpriseResource resource = new TabSysUnionEnterpriseResource();
        resource.setResource(resourceId);
        resource.setEnterpriseId(enterpriseId);
        TabSysUnionEnterpriseResource tabSysUnionEnterpriseResource = this.getByUnionIdAndType(unionId, type);
        if(tabSysUnionEnterpriseResource != null){
            resource.setUnionResourceId(tabSysUnionEnterpriseResource.getUnionResourceId());
            return this.tabSysUnionEnterpriseResourceMapper.updateByPrimaryKeySelective(resource);
        }else {
            resource.setAuthorizationStatus(AuthorizationStatusEnum.NORMAL.getCode());
            resource.setStatus(Constants.NORMAL_STATUS);
            resource.setUpdateTime(new Date());
            resource.setCreateTime(new Date());
            resource.setUnionId(unionId);
            resource.setResourceType(type);
            return this.tabSysUnionEnterpriseResourceMapper.insert(resource);
        }
    }

    @Override
    public TabSysUnionEnterpriseResource getByUnionIdAndType(Integer unionId, int type) {
        List<TabSysUnionEnterpriseResource> list = this.tabSysUnionEnterpriseResourceMapper.getResource(unionId, type);
        if(CollectionUtils.isNotEmpty(list)){
            return list.get(0);
        }
        return null;
    }

    @Override
    public int delResource(Integer unionId, Integer enterpriseId) {
        return this.tabSysUnionEnterpriseResourceMapper.delResource(enterpriseId, unionId);
    }
}
