package com.gic.auth.service.outer.impl;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.dto.MenuDTO;
import com.gic.auth.entity.TabSysMenu;
import com.gic.auth.service.MenuApiService;
import com.gic.auth.service.MenuService;
import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.utils.UserDetailUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.dubbo.rpc.RpcContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
@Service("menuApiService")
public class MenuApiServiceImpl implements MenuApiService {
    @Autowired
    private MenuService menuService;
    @Override
    public ServiceResponse<List<MenuDTO>> getUserMenu(Integer userId, Integer enterpriseId, Integer currentMenu) {
        System.out.println(RpcContext.getContext().getAttachments());
        System.out.println(UserDetailUtils.getUserDetail());
        List<TabSysMenu> menuList = this.menuService.listMenu();
        int level = 1;
        int parentId = 0;
        if(currentMenu != null){
            TabSysMenu menu = this.menuService.getMenuById(currentMenu);
            parentId = currentMenu;
            level = menu.getLevel()+1;
        }
        return ServiceResponse.success(this.treeMenu(menuList, level, parentId));
    }

    @Override
    public ServiceResponse<List<MenuDTO>> getSuperAdminMenu(Integer userId, Integer enterpriseId) {
        return this.getUserMenu(userId, enterpriseId, null);
    }

    private List<MenuDTO> treeMenu(List<TabSysMenu> menuList, int level, int parentId){
        List<MenuDTO> list = null;
        if(level < 5){
            for(TabSysMenu menu : menuList){
                if(level == menu.getLevel() && menu.getIsShow().intValue() == 1 && menu.getParentId().intValue() == parentId){
                    MenuDTO menuDTO = EntityUtil.changeEntityByJSON(MenuDTO.class, menu);
                    menuDTO.setChildren(this.treeMenu(menuList, menu.getLevel().intValue()+1, menuDTO.getMenuId()));
                    if(list == null){
                        list = new ArrayList<>();
                    }
                    list.add(menuDTO);
                }
            }
        }
        return list;
    }
}
