package com.gic.auth.web.controller;

import com.alibaba.fastjson.JSON;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.dto.MenuDTO;
import com.gic.auth.service.MenuApiService;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.response.EnterpriseRestResponse;
import com.gic.enterprise.utils.UserDetailUtils;
import org.apache.dubbo.rpc.RpcContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
public class MenuController {
    @Autowired
    private MenuApiService menuApiService;

    @RequestMapping("login-user-menu")
    public RestResponse loginUserMenu(Integer currentMenu){
        Integer userId = UserDetailUtils.getUserDetail().getUserId();
        Integer enterpriseId = UserDetailUtils.getUserDetail().getEnterpriseId();
        RpcContext.getContext().setAttachment("userDetail", JSON.toJSONString(UserDetailUtils.getUserDetail()));
        ServiceResponse<List<MenuDTO>> userMenu = this.menuApiService.getUserMenu(userId, enterpriseId, currentMenu);
        if(userMenu.isSuccess()){
            return RestResponse.success(userMenu.getResult());
        }
        return EnterpriseRestResponse.failure(userMenu);
    }
}
