package com.gic.auth.web.controller;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.auth.dto.ResourceDTO;
import com.gic.auth.service.ResourceApiService;
import com.gic.auth.web.qo.PageQO;
import com.gic.auth.web.qo.ResourceQO;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.utils.ResultControllerUtils;
import com.gic.enterprise.utils.UserDetailUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 * @Description:
 * @author zhiwj
 * @date 2019/8/29 9:09
 */
@RestController
public class ResourceController {

    @Autowired
    private ResourceApiService resourceApiService;

    @RequestMapping("/save-resource")
    public RestResponse saveResource(ResourceQO resourceQO) {
        ResourceDTO resourceDTO = EntityUtil.changeEntityByOrika(ResourceDTO.class, resourceQO);
        resourceDTO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Integer> serviceResponse = resourceApiService.saveOrUpdateResource(resourceDTO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/del-resource")
    public RestResponse delResource(Integer resourceId) {
        ServiceResponse<Integer> serviceResponse = resourceApiService.delResource(resourceId);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/list-resource")
    public RestResponse listResource(ResourceQO resourceQO, PageQO pageQO) {
        ResourceDTO resourceDTO = EntityUtil.changeEntityByOrika(ResourceDTO.class, resourceQO);
        resourceDTO.setEnterpriseId(UserDetailUtils.getUserDetail().getEnterpriseId());
        ServiceResponse<Page<ResourceDTO>> serviceResponse = resourceApiService.listResource(resourceDTO, pageQO.getCurrentPage(), pageQO.getPageSize());
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/get-resource")
    public RestResponse getResource(Integer resourceId){
        ServiceResponse<ResourceDTO> serviceResponse = resourceApiService.getResource(resourceId);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

}
