package com.gic.auth.web.utils;

import org.apache.commons.lang3.StringUtils;

import com.gic.auth.constant.UserConstants;
import com.gic.commons.util.Md5Util;
import com.gic.enterprise.error.ErrorCode;
import com.gic.enterprise.exception.CommonException;
import com.gic.enterprise.utils.CreateRandomUtils;
/**
 * 用户密码生成
 * @ClassName: UserPasswordUtils 
 * @Description:  
 * @author guojuxing 
 * @date 2019/9/2 2:03 PM 
 */
public class UserPasswordUtils {
    public static String getEncryptPassword(String password) {
        return encryptPassword(password);
    }

    /**
     * 自动生成n位密码
     * @Title: createPasswordAuto 
     * @Description:
      * @author guojuxing  
     * @return  java.lang.String 
      */
    public static String createPasswordAuto(Integer length) {
        if (length == null) {
            length = 8;
        }
        return CreateRandomUtils.getStringRandom(length);
    }

    private static String encryptPassword(String password) {
        Md5Util md5 = new Md5Util();
        return md5.encrypt(password + password);
    }


    /**
     * 获取密码
     * @param passwordType
     * @param password
     * @return
     */
    public static String validPassword(int passwordType, String password, Integer operPasswordType) {
        //加密
        if (UserConstants.CREATE_AUTO == passwordType) {
            //自动随机生成
            return createPasswordAuto(8);
        } else {
            if (operPasswordType == null) {
                operPasswordType = 2;
            }
            if (operPasswordType.intValue() != 1) {
                //如果不等于1，则需要验证密码
                if (StringUtils.isNotBlank(password)) {
                    return password;
                } else {
                    throw new CommonException(ErrorCode.PARAMETER_ERROR.getCode(), "密码不能为空");
                }
            }
            //如果是1，则不需要密码
            return null;
        }
    }
}
